// Fig. 15.12: CircularBufferTest.cs
// Implementing the producer/consumer relationship with a
// circular buffer.
using System;
using System.Threading;

class CircularBufferTest
{
   // create producer and consumer threads and start them
   static void Main( string[] args )
   {
      // create shared object used by threads
      CircularBuffer shared = new CircularBuffer();

      // Random object used by each thread
      Random random = new Random();

      // display shared state before producer
      // and consumer threads begin execution
      Console.Write( shared.CreateStateOutput() );

      // create Producer and Consumer objects
      Producer producer = new Producer( shared, random );
      Consumer consumer = new Consumer( shared, random );

      // create threads for producer and consumer and set 
      // delegates for each thread
      Thread producerThread = 
         new Thread( new ThreadStart( producer.Produce ) );
      producerThread.Name = "Producer";

      Thread consumerThread = 
         new Thread( new ThreadStart( consumer.Consume ) );
      consumerThread.Name = "Consumer";

      // start each thread
      producerThread.Start();
      consumerThread.Start();
   } // end Main
} // end class CircularBufferTest

/**************************************************************************
 * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/